self: super:

{
  userPackages = super.userPackages or {

    # cli
    vimHugeX = self.vimHugeX;
    neovim = self.neovim;
    neovim-remote = self.neovim-remote;
    git = self.git;
    git-lfs = self.git-lfs;
    feh = self.feh;
    ripgrep = self.ripgrep;
    jq = self.jq;
    tree = self.tree;
    dnsutils = self.dnsutils;
    httpie = self.httpie;
    htop = self.htop;
    bc = self.bc;
    pv = self.pv;
    caddy = self.caddy;
    openssl = self.openssl;
    pwgen = self.pwgen;
    gnupg = self.gnupg;
    whois = self.whois;
    traceroute = self.traceroute;
    gnumake = self.gnumake;
    tig = self.tig;
    gettext = self.gettext;
    unzip = self.unzip;
    shellcheck = self.shellcheck;
    mps-youtube = self.python36Packages.mps-youtube;
    mpv = self.mpv;

    # desktop
    adapta-gtk-theme = self.adapta-gtk-theme;
    hicolor-icon-theme = self.hicolor-icon-theme;
    arc-icon-theme = self.arc-icon-theme;
    gmrun = self.gmrun;
    dunst = self.dunst;
    compton = self.compton;
    fcitx-configtool = self.fcitx-configtool;
    volumeicon = self.volumeicon;
    pcmanfm = self.pcmanfm;
    lxappearance = self.lxappearance;
    xdotool = self.xdotool;
    scrot = self.scrot;
    xbacklight = self.xorg.xbacklight;
    libnotify = self.libnotify;

    # apps
    firefox = self.firefox;
    chromium = self.chromium;
    pavucontrol = self.pavucontrol;
    gnumeric = self.gnumeric;
    qterminal = self.lxqt.qterminal;
    networkmanagerapplet = self.gnome3.networkmanagerapplet;
    networkmanager_openvpn = self.gnome3.networkmanager_openvpn;
    keepass = self.keepass.override {
      plugins = [ self.keepass-keeagent ];
    };
    insomnia = self.insomnia;

    # work
    awscli = self.awscli;
    docker = self.docker;
    docker-machine = self.docker-machine;
    docker-machine-kvm = self.docker-machine-kvm;
    docker-machine-kvm2 = self.docker-machine-kvm2;
    docker_compose = self.docker_compose;
    virtmanager = self.virtmanager;
    tmux-cssh = self.tmux-cssh;
    cfn-lint = let
      pkgs = import <nixpkgs-unstable> {};
    in pkgs.python27.pkgs.callPackage ./packages/cfn-lint.nix {};
    cfn_flip = let
      pkgs = import <nixpkgs-unstable> {};
    in pkgs.python27.pkgs.callPackage ./packages/cfn_flip.nix {};
    cntr = self.cntr;

    nix-rebuild = super.writeScriptBin "nix-rebuild" ''
      #!${super.stdenv.shell}
      if ! command -v nix-env &>/dev/null; then
          echo "warning: nix-env was not found in PATH, add nix to userPackages" >&2
          PATH=${self.nix}/bin:$PATH
      fi
      exec nix-env -f '<nixpkgs>' -r -iA userPackages "$@"
    '';

    cssh = super.writeScriptBin "cssh" ''
      #!${super.stdenv.shell}
      exec ${self.tmux-cssh}/bin/tmux-cssh $@
    '';

  };
}
